<template>
  <div class="doc-source">
    <div class="doc-source__actions">
      <doc-copy-to-clipboard :content="sourceValue" />
    </div>
    <!-- eslint-disable vue/no-v-html -->
    <pre class="doc-source__content" v-html="renderedContent" />
    <!-- eslint-enable vue/no-v-html -->
  </div>
</template>

<script>
import highlight from 'highlight.js'
import hXml from 'highlight.js/lib/languages/xml'
import hJs from 'highlight.js/lib/languages/javascript'
import hScss from 'highlight.js/lib/languages/scss'

import DocCopyToClipboard from '../CopyToClipboard/CopyToClipboard.vue'

highlight.registerLanguage('xml', hXml)
highlight.registerLanguage('javascript', hJs)
highlight.registerLanguage('scss', hScss)

export default {
  name: 'DocCodeBlockRenderer',
  components: { DocCopyToClipboard },
  slots: [
    /** @slot Default slot for source code. Is ignored when a `source` prop is given */
    'default',
  ],
  props: {
    /** Code language, for syntax highlighting */
    language: { required: false, type: String, default: null },
    /**
     * Source code.
     *
     * Takes precedence over the slot.
     * Use this prop whenever you need the content _may_ change and needs to be reactive.
     */
    source: { required: false, type: String, default: null },
  },
  data () {
    return {
      renderedContent: '',
      sourceValue: '',
    }
  },
  methods: {
    renderMd (string) {
      return highlight.highlight(string, { language: this.language }).value
    },
  },
  created () {
    this.$nextTick(() => {
      const slotContent = this.$slots.default && this.$slots.default()
      this.sourceValue = this.source || (slotContent && slotContent[0].children.trim())

      this.renderedContent = this.renderMd(this.sourceValue)
    })
  },
  watch: {
    source (newValue) {
      this.renderedContent = this.renderMd(newValue)
    },
  },
}
</script>
